SystemOrganization addCategory: #'OB-Tests-Web'!

TestCase subclass: #OBHtmlGenerationText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBHtmlGenerationText methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:57'!
expectedWindowHtml
	^ '<html><head><title>browser</title><script src="link.js"></script><script src="widgets.js"></script><link rel="stylesheet" href="browser.css" type="text/css" /></head><body><div id="1xelxppx5lx1uakej5rf573gh" class="root"></div><script>link = new Link(window.location);</script></body></html>'
! !

!OBHtmlGenerationText methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:13'!
expectedWindowWithChildHtml
	^ '<html><head><title>browser</title><script src="link.js"></script><script src="widgets.js"></script><link rel="stylesheet" href="browser.css" type="text/css" /></head><body><div id="1xelxppx5lx1uakej5rf573gh" class="root"><div id="1xelxppx5lx1uakej5rf573gh" class="vertical" style="top: 40%; height: 60%"></div></div><script>link = new Link(window.location);</script></body></html>'! !

!OBHtmlGenerationText methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:46'!
id
	^ OBWebIdentifier random: (Random seed: 32445)! !

!OBHtmlGenerationText methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:47'!
test01EmptyWindow
	| widget |
	widget _ OBWebWindow id: self id model: self.
	self assert: widget html = self expectedWindowHtml.
	! !

!OBHtmlGenerationText methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:07'!
test02WindowWithChild
	| widget |
	widget _ OBWebWindow id: self id model: self.
	widget addChild: (OBWebText id: self id model: self).
	self assert: widget html = self expectedWindowWithChildHtml.
	! !

TestCase subclass: #OBWebBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebBuilderTest methodsFor: 'accessing' stamp: 'cwp 10/23/2006 15:51'!
announcer
	^ OBAnnouncer new! !

!OBWebBuilderTest methodsFor: 'accessing' stamp: 'cwp 10/23/2006 15:58'!
columnWithFilter
	| metanode |
	metanode _ OBMetaNode named: 'Root'.
	metanode 
		childAt: #left put: (OBMetaNode named: 'Left');
		childAt: #right put: (OBMetaNode named: 'Right');
		filterClass: OBModalFilter.
	^ OBColumn 
		inPanel: self 
		metaNode: metanode
		node: self! !

!OBWebBuilderTest methodsFor: 'emulating' stamp: 'cwp 10/23/2006 15:57'!
left
	^ {self}! !

!OBWebBuilderTest methodsFor: 'emulating' stamp: 'cwp 10/23/2006 15:57'!
metaNode: aMetanode! !

!OBWebBuilderTest methodsFor: 'emulating' stamp: 'cwp 10/23/2006 15:57'!
right
	^ {self}! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 10/24/2006 14:45'!
tests01BrowserCreatesWindow
	| builder browser |
	builder _ OBWebBuilder new.
	browser _ OBBrowser metaNode: OBFakeNode metagraph node: OBFakeNode new.
	browser buildOn: builder.
	self assert: (builder root isKindOf: OBWebWindow).
	self assert: (builder root model == browser).! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 10/23/2006 15:12'!
tests02BrowserAddsPanels
	| builder browser |
	builder _ OBWebBuilder new.
	browser _ OBBrowser metaNode: OBFakeNode metagraph node: OBFakeNode new.
	browser buildOn: builder.
	self assert: builder root children size = 2.
	self assert: (builder root children first isKindOf: OBWebScroller).
	self assert: (builder root children second isKindOf: OBWebText).! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 10/24/2006 10:39'!
tests03ColumnPanelAddsColumns
	| builder browser |
	builder _ OBWebBuilder new.
	browser _ OBBrowser metaNode: OBFakeNode metagraph node: OBFakeNode new.
	browser navigationPanel buildOn: builder.
	self assert: builder root children size = 4.
	builder root children do: [:ea | self assert: (ea isKindOf: OBWebPane)].! !

!OBWebBuilderTest methodsFor: 'tests' stamp: 'cwp 10/24/2006 10:39'!
tests04ColumnAddsList
	| builder column |
	builder _ OBWebBuilder new.
	column _ self columnWithFilter.
	column buildOn: builder.
	self assert: (builder root isKindOf: OBWebPane).
	self assert: (builder root children first isKindOf: OBWebList)! !

TestCase subclass: #OBWebIdentifierTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebIdentifierTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 10:56'!
test01DefaultSize
	| id |
	id _ OBWebIdentifier new.
	self assert: id size = 16! !

!OBWebIdentifierTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:43'!
test02Print
	| id |
	id _ OBWebIdentifier random: (Random seed: 32655).
	self assert: id printString = '5hrndt4hbpbym40b4s1p5qw5e'! !

TestCase subclass: #OBWebListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:56'!
createList
	^ OBWebList 
		id: (OBWebIdentifier random: (Random seed: 43222))
		model: self! !

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 12:05'!
list
	^ #('Alpha' 'Beta' 'Gamma')! !

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 12:05'!
selection
	^ 2! !

!OBWebListTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:11'!
test01InitializesWithListAndSelection
	| list init |
	list _ self createList.
	init _ String streamContents: [:s | list jsInitializeOn: s].
	self assert: init = 'Widget.get("an18u9s6ubfe77f1ug6yo74uv").update({"selection": 1, "items": ["Alpha", "Beta", "Gamma"]});'! !

TestCase subclass: #OBWebWindowTest
	instanceVariableNames: 'id delivered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Web'!

!OBWebWindowTest methodsFor: 'emulating' stamp: 'cwp 10/25/2006 19:06'!
addWithAllChildrenTo: anIdentityDictionary 
	anIdentityDictionary at: self identifier put: self! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 12:15'!
createWidget
	^ OBWebWindow 
		id: (OBWebIdentifier random: (Random seed: 43222))
		model: self! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 18:59'!
handleMessage: aJsonObject
	delivered _ aJsonObject! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:52'!
id
	^ id! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:52'!
identifier
	^ id printString! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 18:53'!
setUp
	id _ OBWebIdentifier seed: 44355.
	! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:32'!
test01InitializesWithWidgetInit
	| list init |
	list _ self createWidget.
	init _ String streamContents: [:s | list jsInitializeOn: s].
	self assert: init = 'Widget.init("an18u9s6ubfe77f1ug6yo74uv"); '! !

!OBWebWindowTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2006 20:12'!
test02DispatchesMessagesById
	| window message |
	window _ self createWidget.
	window addChild: self.
	message _ OBAjaxMessage
				receiver: self identifier
				selector: #ackMessage
				arguments: #().
	window processMessage: message.
	self assert: delivered == message
				! !
